                    Computer Science 481/681
                           Quiz 3            Name____________________

1. ICMP packets are

   a. Encapsulated in IP         b. Sent standalone without
      datagrams.                    even an ethernet header

   c. Have an ethernet header    d. May be sent any of the above
      but no IP header.             ways depending on situation

2. Identify three DISTINCT types of messages of which the receipt
   should never result in generation of an ICMP error response.
   (We identified 5 in class.)

   a.

   b.

   c.

3. The other type of general ICMP message is the "query".  We
   identified 3 query types.. One was echo (ping). What were the
   other two.

   a.

   b.

4. The reason a "regular" unprivileged programmer can't write an
   ICMP application is that:

   a. The getprotobyname() function     b. Creation of a socket of
      fails since ICMP is a protected      type SOCK_RAW fails on Unix
      protocol.                            systems unless the caller is
                                           running as root.

   c. The gethostbyname() function      d. All of the above
      is priviledged.

5. In which of the following cases would an ICMP message typically
   NOT be generated.

   a. IP discards a datagram because    b. A datagram is sent to a
      its time expired.                    TCP port on which on process
                                           is listening.

   c. A packet reaches a router which   d. IP is forced to fragment
      has no explicit or default way       a packet.
      to route it.

The next few questions apply to the SLIP network shown on the board.

6. Suppose I have correctly entered the ifconfig command defining
   the SLIP interfaces on jmw2 and jmw3 but that no routes have been
   added to jmw2's table. If I enter the following commands on jmw2
   > ping 130.127.48.24

   a. The command will succeed    b. The ICMP Echo Req will not even
                                     get to jmw
   c. The request will get there
      but the response won't get
      back.

7. Now suppose I enter route add default 130.127.48.249 on jmw2
   and retry the ping command.

   a. The command will succeed    b. The ICMP Echo Req will not even
                                     get to jmw
   c. The request will get there
      but the response won't get
      back.

8. We said that "proxy" arp was useful in making this network run
   correctly. The proxy arp command had to be entered on system

   a. jmw                         b. jmw2

   c. jmw3                        d. all of the above

9. The proxy arp command contained:

   a. The HW address of jmw2 and   a. The HW address of jmw3 and
      the IP address of jmw3          the IP address of jmw2

   c. The HW address of jmw  and   a. The HW address of jmw2 and
      the IP address of jmw2          the IP address of jmw2

10. We said in class that the development of the traceroute program
    was motivated by deficiencies in the possible use of the record
    route option in conjunction with PING.   Identify 2 of the
    problems:

    a.


    b.

